function gfhelp
% Operations supported for Galois Field arrays:
%
%   + -          - Addition and subtraction of Galois arrays.
%  
%   * / \        - Matrix multiplication and division of Galois arrays.
%  
%   .* ./ .\     - Elementwise multiplication and division of Galois arrays
%  
%   ^            - Matrix exponentiation of Galois array.
%  
%   .^           - Elementwise exponentiation of Galois array.
%  
%   ' .'         - Transpose of Galois array.
%  
%   ==, ~=       - Relational operators for Galois arrays.
%      
%   all          - True if all elements of a Galois vector are nonzero.
%   any          - True if any element of a Galois vector is nonzero.
%   conv         - Convolution of Galois vectors.
%   convmtx      - Convolution matrix of Galois field vector.
%   cosets       - Produce cyclotomic cosets for a Galois field.
%   deconv       - Deconvolution and polynomial division.
%   det          - Determinant of square Galois matrix.
%   dftmtx       - Discrete Fourier transform matrix in a Galois field.
%   diag         - Diagonal Galois matrices and diagonals of a Galois matrix.
%   fft          - Discrete Fourier transform.
%   filter       - One-dimensional digital filter over a Galois field.
%   gf           - Create a Galois field array.
%   gftable      - Generate a file to accelerate Galois field computations.
%   ifft         - Inverse discrete Fourier transform.
%   inv          - Inverse of Galois matrix.
%   isprimitive  - Check whether a polynomial over a Galois field is primitive.
%   length       - Length of Galois vector.
%   log          - Logarithm in a Galois field.
%   lu           - Lower-Upper triangular factorization of Galois array.
%   minpoly      - Find the minimal polynomial for a Galois element.
%   mldivide     - Matrix left division \ of Galois arrays.
%   polyval      - Evaluate polynomial in Galois field.
%   primpoly     - Find primitive polynomials for a Galois field.
%   rank         - Rank of a Galois array.
%   reshape      - Reshape Galois array.
%   roots        - Find polynomial roots across a Galois field.
%   size         - Size of Galois array.
%   tril         - Extract lower triangular part of Galois array.
%   triu         - Extract upper triangular part of Galois array.
%
% Type "help gf/function" for the individual help entry of each function. 

%   Copyright 1996-2002 The MathWorks, Inc.
%   $Revision: 1.2 $   $ $

help gfhelp
